#include "asm86.h"
#include "ti86asm.inc"
#include "ti86math.inc"
#include "ti86ops.inc"
#include "ti86abs.inc"

.org _asm_exec_ram

_delvar 	equ	475Fh
_FINDSYM	equ	46CBh
_convop1	equ	5577h 

main:
	ld hl,ans			; source = ans
	rst 20h				; move 10 bytes from hl to OP1
	rst 10h				; (Findsym) carry flag set if var dosen't exist
	jr c,exit			; if so, quit without doing anything
	and 1fh				; mask out flags, a = vartype
	cp 04h				; do we have a real list?
	jr nz,exit			; if not, quit without doing anything
	ld a,b				; copy abs address of list from bde to ahl
	ex de,hl
	call _load_ram_ahl	; loads the correct page and sets hl as pointer to list
	ld a,(hl)			; a = length of list
	cp 5				; do we have 5 elements?
	jr nz,exit			; if not, quit without doing anything
	inc hl
	inc hl				; move to start of first element
	call getelement		; get x1
	ld (x1),a
	call getelement		; get y1
	ld (y1),a
	call getelement		; get x2
	ld (x2),a
	call getelement		; get y2
	ld (y2),a
	call getelement		; get color
	ld	h,a
	ld a,(x1)
	ld b,a
	ld a,(y1)
	ld c,a
	ld a,(x2)
	ld d,a
	ld a,(y2)
	ld e,a

	call _ILine			; draw the line
	ret

getelement:
	push de				; save de
	push hl
	rst 20h				; move 10 bytes from hl to OP1
	pop hl
	ld d,0				; de = 10
	ld e,10
	add hl,de			; hl = hl + de (points to next element)
	push hl				; save hl
	call _convop1		; a = What was in op1
	pop hl				; restore hl
	pop	de				; restore de
	ret 

exit:
	call	_getkey			; wait for keypress (debugging)
	ret				; return to system

ans:
	.db		0,$03,"Ans"

x1:	.db	0
y1:	.db	0
x2:	.db	0
y2:	.db	0

.end
